package CDRSvcsBSCDLookupUIDSvcSOA4_TSUnitTestsGt_287114025;


public class jcdDynamicConfig
{

    private static final java.util.TreeMap propsCache = new java.util.TreeMap();

    public synchronized void addProperties( String psProFileName, java.util.Properties props )
    {
        propsCache.put( psProFileName, props );
        logger.debug( "\n===>>> Added properties file " + psProFileName + " to properties cache" );
    }

    public synchronized void updateProperties( String psProFileName, java.util.Properties props )
    {
        propsCache.put( psProFileName, props );
        logger.debug( "\n===>>> Updated properties file " + psProFileName + " in properties cache" );
    }

    public synchronized java.util.Properties getProperties( String psProFileName )
    {
        return (java.util.Properties) propsCache.get( psProFileName );
    }

    private static boolean blKeepRefreshing = true;

    public synchronized boolean isKeepRefreshing()
    {
        return blKeepRefreshing;
    }

    public synchronized void setKeepRefreshing( boolean keep_refreshing )
    {
        blKeepRefreshing = keep_refreshing;
    }

    public void getProperties( com.stc.udtString_307407100.Udtstring input, xsd.Properties_Properties859331009.Properties output )
        throws Throwable
    {
        java.util.Properties cachedProps = getProperties( input.getValue() );
        if (cachedProps == null) {
            // 
            // add prop file to the cache
            // 
            try {
                java.util.Properties props = new java.util.Properties();
                props.load( this.getClass().getClassLoader().getResourceAsStream( input.getValue() ) );
                String keep_refreshing = props.getProperty( "keep_refreshing" );
                if (keep_refreshing != null && !java.util.regex.Pattern.matches( "(?i)true|1|-1|(?i)t", keep_refreshing )) {
                    setKeepRefreshing( false );
                }
                addProperties( input.getValue(), props );
            } catch ( java.io.IOException ioe ) {
                String sMsg = "Properties File [" + input.getValue() + "] not found in classpath";
                throw new Exception( sMsg, ioe );
            }
        } else if (blKeepRefreshing) {
            // 
            // load properties each time through the collaboration until told to stop
            // the keep_refreshing property, when set to anything other than
            // (case insensitive) true, t, 1 or -1 will stop refresh
            // 
            try {
                java.util.Properties props = new java.util.Properties();
                props.load( this.getClass().getClassLoader().getResourceAsStream( input.getValue() ) );
                String keep_refreshing = props.getProperty( "keep_refreshing" );
                if (keep_refreshing != null && !java.util.regex.Pattern.matches( "(?i)true|1|-1|(?i)t", keep_refreshing )) {
                    setKeepRefreshing( false );
                }
                updateProperties( input.getValue(), props );
            } catch ( java.io.IOException ioe ) {
                String sMsg = "Properties File [" + input.getValue() + "] not found in classpath";
                throw new Exception( sMsg, ioe );
            }
        }
        // 
        cachedProps = getProperties( input.getValue() );
        // 
        // Enumerate all system properties
        java.util.Enumeration eNum = cachedProps.propertyNames();
        int i = 0;
        for (; eNum.hasMoreElements();) {
            // Get property name
            String propName = (String) eNum.nextElement();
            // Get property value
            String propValue = (String) cachedProps.get( propName );
            output.getProperty( i ).getX_sequence_B().setName( propName );
            output.getProperty( i ).getX_sequence_B().setValue( propValue );
            i++;
        }
    }

    public com.stc.codegen.logger.Logger logger;

    public com.stc.codegen.alerter.Alerter alerter;

    public com.stc.codegen.util.CollaborationContext collabContext;

    public com.stc.codegen.util.TypeConverter typeConverter;

}
